/*
 * Copyright (c) Huawei Technologies Co., Ltd. 2020-2024. All rights reserved.
 */

#ifndef DPC_IMPL_TYPE_LEFTROADEDGE_H
#define DPC_IMPL_TYPE_LEFTROADEDGE_H

#include "impl_type_uint32.h"
#include "dpc/impl_type_array_rmrdedgelftgeometry_6.h"
#include "impl_type_boolean.h"
#include "impl_type_uint8.h"

namespace dpc {
struct LeftRoadEdge {
    ::UInt32 rm_rdedgelft_id{ 0U };
    ::dpc::array_RMRdEdgeLftgeometry_6 rm_rdedgelft_geometry{};
    ::Boolean rm_rdedgelft_edoutview{ false };
    ::UInt8 rm_lftrdedgesnsrsource{ 0U };

    static bool IsPlane()
    {
        return false;
    }


    using IsEnumerableTag = void;
    template<typename F>
    void enumerate(F& fun)
    {
        fun(rm_rdedgelft_id);
        fun(rm_rdedgelft_geometry);
        fun(rm_rdedgelft_edoutview);
        fun(rm_lftrdedgesnsrsource);
    }

    template<typename F>
    void enumerate(F& fun) const
    {
        fun(rm_rdedgelft_id);
        fun(rm_rdedgelft_geometry);
        fun(rm_rdedgelft_edoutview);
        fun(rm_lftrdedgesnsrsource);
    }

    template<typename F>
    void enumerate_internal(F& fun)
    {
        fun("rm_rdedgelft_id", rm_rdedgelft_id);
        fun("rm_rdedgelft_geometry", rm_rdedgelft_geometry);
        fun("rm_rdedgelft_edoutview", rm_rdedgelft_edoutview);
        fun("rm_lftrdedgesnsrsource", rm_lftrdedgesnsrsource);
    }

    template<typename F>
    void enumerate_internal(F& fun) const
    {
        fun("rm_rdedgelft_id", rm_rdedgelft_id);
        fun("rm_rdedgelft_geometry", rm_rdedgelft_geometry);
        fun("rm_rdedgelft_edoutview", rm_rdedgelft_edoutview);
        fun("rm_lftrdedgesnsrsource", rm_lftrdedgesnsrsource);
    }

    friend bool operator==(const ::dpc::LeftRoadEdge& lhs, const ::dpc::LeftRoadEdge& rhs) noexcept
    {
        return (lhs.rm_rdedgelft_id == rhs.rm_rdedgelft_id) && (lhs.rm_rdedgelft_geometry == rhs.rm_rdedgelft_geometry) && (lhs.rm_rdedgelft_edoutview == rhs.rm_rdedgelft_edoutview) && (lhs.rm_lftrdedgesnsrsource == rhs.rm_lftrdedgesnsrsource);
    }
};
} // namespace dpc


#endif // DPC_IMPL_TYPE_LEFTROADEDGE_H
